#!/usr/bin/env python

# lucky dragon


def num_string(s):
	return [ord(i) for i in s]
	
def modulate(nums):
	return [(n - 7) % 65536 for n in nums]

def antimodulate(nums):
	return [(n + 7) % 65536 for n in nums]

def bit_string(nums):
	return [bool(j & (2**i))  for j in nums for i in range(15,-1,-1)]



if __name__ == '__main__':
	msg = [bit_string(modulate([0x0000,0xFEFF,0x0001, 0x0002] + num_string("hlpndrjeeshtgdrenrusbnstun6r"))),
			bit_string(modulate(num_string("mysiz40ntrysbtgbnfndwigginptr") + [0x0003, 0x0004, 0x0000]))]
	
	from PIL import Image
	import sys
	if len(sys.argv) != 5:
		print "Usage: luckydragon.py infile outfile xstart ystart"
		exit(1)
	dummy, infile, outfile, xstart, ystart = sys.argv
	xstart = int(xstart) * 16
	ystart = int(ystart) * 16
	im = Image.open(infile)
	
	y = ystart
	for line in msg:
		oddrow = y % 2
		sign = 1 - 2 * oddrow
		lc = len(line)
		x = xstart + (lc + (lc / 8) + (lc / (7*8))) * oddrow
		for i,bit in enumerate(reversed(line) if oddrow else line):
			if not (i % 8):
				x += sign
				if not (x % 8):
					x += sign
			im.putpixel((x,y),int(bit))
			x += sign
			
		y += 1
		
	for line in msg:
		ol = []
		for i in range(len(line) / 16):
			nxt_chr = line[i*16:(i+1)*16]
			ol += [sum((bit) * (2**(15 - i)) for i,bit in enumerate(nxt_chr))]
		ol = antimodulate(ol)
		print "".join(chr(n % 256) for n in ol)
	im.save(outfile)

	
